/*
 * myTest.cpp
 *
 *  Created on: Jun 11, 2014
 *      Author: nick
 */

#include <stdio.h>
#include <curl/curl.h>
#include <string>
#include <iostream>
#include <errno.h>
#include <cstring>
#include <iconv.h>
#include <fstream>
#include <map>
#include "table.h"

using namespace std;

extern int errno;
bool doConv(const char* pszTarget, string& strResult);

int curl_writefunc(char* ptr, size_t size, size_t num, string* pStr)
{
	pStr->append(ptr, size * num);
	return num * size;
}

const char BASE_CHAR='a';

string urlEncode(const string& str)
{
    string result;
    for (size_t i = 0; i < str.size(); i++)
    {
        if ((str[i] >= '0' && str[i] <= '9') || (str[i] >= 'A' && str[i] <= 'Z')
                || (str[i] >= 'a' && str[i] <= 'z'))
        {
            result += str[i];
        }
        else
        {
            const unsigned char MASK1 = 0xF0;
            const unsigned char MASK2 = 0x0F;
            unsigned char ch;

            switch (str[i])
            {
            case '-':
            case '_':
            case '.':
            case '!':
            case '~':
            case '*':
            case '\'':
            case '(':
            case ')':
            case '"':
                result += str[i];
                break;
            default:
                ch = (str[i] & MASK1) >> 4;
                result += '%';

                if (ch > 9)
                {
                    ch = ch - 10 + BASE_CHAR;
                }
                else
                {
                    ch = ch + '0';
                }
                result += ch;
                ch = str[i] & MASK2;
                if (ch > 9)
                {
                    ch = ch - 10 + BASE_CHAR;
                }
                else
                {
                    ch = ch + '0';
                }
                result += ch;
                break;
            }
        }
    }
    return result;
}

bool download(const string& strUrl, string& strResult)
{
	bool bResult = false;
	CURL *curl;
	CURLcode res;

	curl = curl_easy_init();
	if (curl)
	{
		curl_easy_setopt(curl, CURLOPT_URL, strUrl.c_str());
		/* example.com is redirected, so we tell libcurl to follow redirection */
		curl_easy_setopt(curl, CURLOPT_FOLLOWLOCATION, 1L);

		curl_easy_setopt(curl, CURLOPT_FILE, &strResult);

		curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, curl_writefunc);

		/* Perform the request, res will get the return code */
		res = curl_easy_perform(curl);
		/* Check for errors */
		if (res == CURLE_OK)
		{
			if (strResult.size() > 0)
			{
				if (strResult.find("400 Bad Request") == string::npos)
				{
					cout << "download:" << endl;
					cout << "strResult:" << strResult << endl;
					bResult = true;
				}
			}
		}

		/* always cleanup */
		curl_easy_cleanup(curl);
		//cout << "contents: " << endl << strResult << endl;
	}
	return bResult;
}
char  EnclodingList[]= "ANSI_X3.4-1968 ANSI_X3.4-1986  ASCII "
		"CP367 IBM367 ISO-IR-6 ISO646-US ISO_646.IRV:1991 US US-ASCII " // CSASCII"
		"UTF-8 ISO-10646-UCS-2 UCS-2 CSUNICODE "
		"UCS-2BE UNICODE-1-1 UNICODEBIG CSUNICODE11 UCS-2LE UNICODELITTLE ISO-10646-UCS-4 UCS-4 CSUCS4 UCS-4BE UCS-4LE UTF-16 UTF-16BE UTF-16LE UTF-32 UTF-32BE "
		"UTF-32LE  UNICODE-1-1-UTF-7 UTF-7 CSUNICODE11UTF7 UCS-2-INTERNAL UCS-2-SWAPPED UCS-4-INTERNAL  UCS-4-SWAPPED  C99 JAVA  "
		"CP819 IBM819 ISO-8859-1 ISO-IR-100 ISO8859-1 ISO_8859-1 ISO_8859-1:1987 L1 LATIN1 CSISOLATIN1 ISO-8859-2 ISO-IR-101 ISO8859-2 ISO_8859-2 "
		"ISO_8859-2:1987 L2 LATIN2 CSISOLATIN2  ISO-8859-3 ISO-IR-109 ISO8859-3 ISO_8859-3 ISO_8859-3:1988 L3 LATIN3 CSISOLATIN3 "
		"ISO-8859-4 ISO-IR-110 ISO8859-4 ISO_8859-4 ISO_8859-4:1988 L4 LATIN4 CSISOLATIN4 "
		"CYRILLIC ISO-8859-5 ISO-IR-144 ISO8859-5 ISO_8859-5 ISO_8859-5:1988 CSISOLATINCYRILLIC "
		"ARABIC ASMO-708 ECMA-114 ISO-8859-6 ISO-IR-127 ISO8859-6 ISO_8859-6 ISO_8859-6:1987 CSISOLATINARABIC "
		"ECMA-118 ELOT_928 GREEK GREEK8 ISO-8859-7 ISO-IR-126 ISO8859-7 ISO_8859-7 ISO_8859-7:1987 ISO_8859-7:2003 CSISOLATINGREEK "
		"HEBREW ISO-8859-8 ISO-IR-138 ISO8859-8 ISO_8859-8 ISO_8859-8:1988 CSISOLATINHEBREW "
		"ISO-8859-9 ISO-IR-148 ISO8859-9 ISO_8859-9 ISO_8859-9:1989 L5 LATIN5 CSISOLATIN5 "
		"ISO-8859-10 ISO-IR-157 ISO8859-10 ISO_8859-10 ISO_8859-10:1992 L6 LATIN6 CSISOLATIN6 "
		"ISO-8859-11 ISO8859-11 ISO_8859-11  ISO-8859-13 ISO-IR-179 ISO8859-13 ISO_8859-13 L7 LATIN7 "
		"ISO-8859-14 ISO-CELTIC ISO-IR-199 ISO8859-14 ISO_8859-14 ISO_8859-14:1998 L8 LATIN8 "
		"ISO-8859-15 ISO-IR-203 ISO8859-15 ISO_8859-15 ISO_8859-15:1998 LATIN-9 "
		"ISO-8859-16 ISO-IR-226 ISO8859-16 ISO_8859-16 ISO_8859-16:2001 L10 LATIN10 "
		"KOI8-R CSKOI8R KOI8-U KOI8-RU CP1250 MS-EE WINDOWS-1250 CP1251 MS-CYRL WINDOWS-1251 CP1252 MS-ANSI WINDOWS-1252 "
		"CP1253 MS-GREEK WINDOWS-1253 CP1254 MS-TURK WINDOWS-1254 CP1255 MS-HEBR WINDOWS-1255 CP1256 MS-ARAB WINDOWS-1256 CP1257 WINBALTRIM WINDOWS-1257 "
		"CP1258 WINDOWS-1258 850 CP850 IBM850 CSPC850MULTILINGUAL 862 CP862 IBM862 CSPC862LATINHEBREW 866 CP866 IBM866 CSIBM866 MAC MACINTOSH MACROMAN CSMACINTOSH "
		" MACCENTRALEUROPE MACICELAND MACCROATIAN MACROMANIA MACCYRILLIC MACUKRAINE MACGREEK MACTURKISH MACHEBREW MACARABIC MACTHAI HP-ROMAN8 R8 ROMAN8 CSHPROMAN8 "
		"NEXTSTEP ARMSCII-8 GEORGIAN-ACADEMY GEORGIAN-PS KOI8-T CP154 CYRILLIC-ASIAN PT154 PTCP154 CSPTCP154 KZ-1048 RK1048 STRK1048-2002 CSKZ1048 "
		"MULELAO-1 CP1133 IBM-CP1133 ISO-IR-166 TIS-620 TIS620 TIS620-0 TIS620.2529-1 TIS620.2533-0 TIS620.2533-1 CP874 WINDOWS-874 "
		"VISCII VISCII1.1-1 CSVISCII TCVN TCVN-5712 TCVN5712-1 TCVN5712-1:1993 ISO-IR-14 ISO646-JP JIS_C6220-1969-RO JP CSISO14JISC6220RO  "
		"JISX0201-1976 JIS_X0201 X0201 CSHALFWIDTHKATAKANA ISO-IR-87 JIS0208 JIS_C6226-1983 JIS_X0208 JIS_X0208-1983 JIS_X0208-1990 X0208 CSISO87JISX0208 "
		"ISO-IR-159 JIS_X0212 JIS_X0212-1990 JIS_X0212.1990-0 X0212 CSISO159JISX02121990 "
		"CN GB_1988-80 ISO-IR-57 ISO646-CN CSISO57GB1988 CHINESE GB_2312-80 ISO-IR-58 CSISO58GB231280 CN-GB-ISOIR165 ISO-IR-165 "
		"ISO-IR-149 KOREAN KSC_5601 KS_C_5601-1987 KS_C_5601-1989 CSKSC56011987 "
		"EUC-JP EUCJP EXTENDED_UNIX_CODE_PACKED_FORMAT_FOR_JAPANESE CSEUCPKDFMTJAPANESE "
		"MS_KANJI SHIFT-JIS SHIFT_JIS SJIS CSSHIFTJIS "
		"CP932 ISO-2022-JP CSISO2022JP ISO-2022-JP-1 ISO-2022-JP-2 CSISO2022JP2 CN-GB EUC-CN EUCCN GB2312 CSGB2312 GBK CP936 MS936 WINDOWS-936 GB18030 "
		"ISO-2022-CN CSISO2022CN ISO-2022-CN-EXT HZ HZ-GB-2312 EUC-TW EUCTW CSEUCTW BIG-5 BIG-FIVE BIG5 BIGFIVE CN-BIG5 CSBIG5 CP950 BIG5-HKSCS:1999 "
		"BIG5-HKSCS:2001 BIG5-HKSCS BIG5-HKSCS:2004 BIG5HKSCS EUC-KR EUCKR CSEUCKR CP949 UHC CP1361 JOHAB ISO-2022-KR CSISO2022KR " ;
//		"CP856 CP922 CP943 CP1046 CP1124 CP1129 CP1161 IBM-1161 IBM1161 CSIBM1161 CP1162 IBM-1162 IBM1162 CSIBM1162 CP1163 IBM-1163 IBM1163 CSIBM1163 "
//		"DEC-KANJI DEC-HANYU 437 CP437 IBM437 CS PC8CODEPAGE437 CP737 CP775 IBM775 CSPC775BALTIC 852 CP852 IBM852 CSPCP852 CP853 855 CP855 IBM855 CSIBM855 "
//		"857 CP857 IBM857 CSIBM857  CP858 860 CP860 IBM860 CSIBM860 861 CP-IS CP861 IBM861 CSIBM861  863 CP863 IBM863 CSIBM863 CP864 IBM864 CSIBM864 "
//		"865 CP865 IBM865 CSIBM865  869 CP-GR CP869 IBM869 CSIBM869 CP1125 EUC-JISX0213 SHIFT_JISX0213 ISO-2022-JP-3 BIG5-2003 ISO-IR-230 TDS565 ATARI ATARIST "
//		" RISCOS-LATIN1 ";

const char* pszUrl = "http://www.staroceans.net/e-book/";

bool myConv()
{
	char* ptr = EnclodingList;
	ptr = strtok(EnclodingList, " ");
	while ( ptr != NULL)
	{
		string strName;
		if (doConv(ptr, strName))
		{
			string strUrl = pszUrl;
			strUrl += urlEncode(strName);

			string strResult;
			if (download(strUrl, strResult))
			{
				cout << "encoding: " << ptr << "successfully download " << endl;

			}
		}
		ptr = strtok(NULL, " ");
	}
	return true;
}
void ch2dec(char& ch)
{
	if (ch > 9)
	{
		ch = ch - 10 + BASE_CHAR;
	}
	else
	{
		ch = ch + '0';
	}
}

void printHex(const string& str)
{
    const unsigned char MASK1 = 0xF0;
    const unsigned char MASK2 = 0x0F;
	for (size_t i = 0; i < str.size(); i ++)
	{
		char ch = (str[i] & MASK1) >> 4;
		ch2dec(ch);
		cout << ch << "\t";
		ch = str[i] & MASK2;
		ch2dec(ch);
		cout << ch << "\t";
	}
}

bool myEncode()
{
	char* ptr = EnclodingList;
	ptr = strtok(EnclodingList, " ");

	while ( ptr != NULL)
	{
		string strName;
		if (doConv(ptr, strName))
		{
			string strResult = urlEncode(strName);

			cout << "encoding: " << ptr << "successfully convert to: "  << endl;
			printHex(strResult);
		}
		ptr = strtok(NULL, " ");
	}
}

char dst[1024];
char* pszFileName = "嵌入式 系统 Boot Loader 技术内幕.pdf";
bool doConv(const char* pszTarget, string& strResult)
{

	iconv_t conv = iconv_open(pszTarget, "UTF-8");
	if (conv == (iconv_t)(-1))
	{
		//cout << "[" << pszTarget << "] cannot be initialized " << endl;
		return false;
	}
	char* pIn = pszFileName;
	char* pOut = dst;
	size_t srclen = strlen(pszFileName);
	size_t dstlen = 1024;
	int result = iconv(conv, &pIn, &srclen, &pOut, &dstlen);
	iconv_close(conv);
	if (result == -1)
	{
		//cout << "encoding[" << pszTarget << "]" << strerror(errno) << endl;
		return false;
	}
	else
	{
		//cout << "encoding[" << pszTarget << "] succeed" << endl;
		strResult.assign(dst, dstlen);
		return true;
	}
}

void test5()
{
	string str(pszFileName);
	for (size_t i = 0; i < str.size(); i ++)
	{
		fprintf(stdout, "[%hhu]", str[i]);
	}
}

void test4()
{
	ifstream in("table.csv");
	ofstream out("table.h");
	char buffer[256];
	int number;
	out << "struct NameIndexPair\n{\nint index;\n char* name;\n};" << endl
			<< "const NameIndexPair[] = {" << endl;

	while (!in.eof())
	{
		in >> buffer;
		in >> number;
		if (in.eof())
		{
			break;
		}
		out << "{" << number << ",\"" << buffer <<"\"" << "}," << endl;
	}
	out << "};" << endl;
}

void test3(map<unsigned short, string>& indexStringMap)
{
	for (size_t i = 0; i < sizeof(nameIndexPair)/sizeof(nameIndexPair[0]); i ++)
	{
		indexStringMap[nameIndexPair[i].index] = nameIndexPair[i].name;
	}
}

void test2()
{
	map<unsigned short, string> indexStringMap;
	test3(indexStringMap);

	string str(pszFileName);
	fprintf(stdout, "%s", pszUrl);
	for (size_t i = 0; i < str.size(); i ++)
	{
		map<unsigned short, string>::const_iterator it;
		unsigned char index = str[i];
		it = indexStringMap.find(index);
		if (it != indexStringMap.end())
		{
			fprintf(stdout, "&%s;", it->second.c_str());
		}
		else
		{
			fprintf(stdout, "&#%hhu;", it->first);
		}
	}
}

int main()
{
	//myConv();
	//myEncode();
	//test5();
	//test4();
	test2();
	return 0;

}
